import * as interfaces from "./interfaces";
import { interfaces as inversifyInterfaces } from "inversify";
declare let helpers: {
    annotate: <T>(constructor: inversifyInterfaces.Newable<T>, dependencies?: (string | symbol | inversifyInterfaces.Newable<any> | inversifyInterfaces.Abstract<any> | interfaces.BasicInjection | interfaces.NamedInjection | interfaces.TaggedInjection)[]) => void;
    register: (container: inversifyInterfaces.Container) => <T>(identifier: string | symbol | inversifyInterfaces.Newable<T> | inversifyInterfaces.Abstract<T>, dependencies?: (string | symbol | inversifyInterfaces.Newable<any> | inversifyInterfaces.Abstract<any> | interfaces.BasicInjection | interfaces.NamedInjection | interfaces.TaggedInjection)[], constraint?: ((binding: inversifyInterfaces.BindingInWhenOnSyntax<T>) => void) | undefined) => (constructor: inversifyInterfaces.Newable<T>) => void;
    registerSelf: (container: inversifyInterfaces.Container) => <T>(dependencies?: (string | symbol | inversifyInterfaces.Newable<any> | inversifyInterfaces.Abstract<any> | interfaces.BasicInjection | interfaces.NamedInjection | interfaces.TaggedInjection)[], constraint?: ((binding: inversifyInterfaces.BindingInWhenOnSyntax<T>) => void) | undefined) => (constructor: inversifyInterfaces.Newable<T>) => void;
    registerConstantValue: (container: inversifyInterfaces.Container) => <T>(identifier: string | symbol | inversifyInterfaces.Newable<T> | inversifyInterfaces.Abstract<T>, value: T, constraint?: ((binding: inversifyInterfaces.BindingWhenOnSyntax<T>) => void) | undefined) => void;
    registerDynamicValue: (container: inversifyInterfaces.Container) => <T>(identifier: string | symbol | inversifyInterfaces.Newable<T> | inversifyInterfaces.Abstract<T>, func: (context: inversifyInterfaces.Context) => T, constraint?: ((binding: inversifyInterfaces.BindingInWhenOnSyntax<T>) => void) | undefined) => void;
    registerConstructor: (container: inversifyInterfaces.Container) => <T>(identifier: string | symbol | inversifyInterfaces.Newable<T> | inversifyInterfaces.Abstract<T>, constraint?: ((binding: inversifyInterfaces.BindingWhenOnSyntax<T>) => void) | undefined) => (constructor: inversifyInterfaces.Newable<T>) => void;
    registerFunction: (container: inversifyInterfaces.Container) => <T extends Function>(identifier: string | symbol | inversifyInterfaces.Newable<T> | inversifyInterfaces.Abstract<T>, func: T, constraint?: ((binding: inversifyInterfaces.BindingWhenOnSyntax<T>) => void) | undefined) => void;
    registerAutoFactory: (container: inversifyInterfaces.Container) => <T1, T2>(factoryIdentifier: string | symbol | inversifyInterfaces.Newable<T1> | inversifyInterfaces.Abstract<T1>, serviceIdentifier: string | symbol | inversifyInterfaces.Newable<T2> | inversifyInterfaces.Abstract<T2>, constraint?: ((binding: inversifyInterfaces.BindingWhenOnSyntax<T1>) => void) | undefined) => void;
    registerFactory: (container: inversifyInterfaces.Container) => <T1, T2>(identifier: string | symbol | inversifyInterfaces.Newable<T1> | inversifyInterfaces.Abstract<T1>, factory: inversifyInterfaces.FactoryCreator<T2>, constraint?: ((binding: inversifyInterfaces.BindingWhenOnSyntax<T1>) => void) | undefined) => void;
    registerProvider: (container: inversifyInterfaces.Container) => <T1, T2>(identifier: string | symbol | inversifyInterfaces.Newable<T1> | inversifyInterfaces.Abstract<T1>, provider: inversifyInterfaces.ProviderCreator<T2>, constraint?: ((binding: inversifyInterfaces.BindingWhenOnSyntax<T1>) => void) | undefined) => void;
};
export { interfaces, inversifyInterfaces, helpers };
