import { interfaces } from "inversify";
import * as helperInterfaces from "./interfaces";
declare function register(container: interfaces.Container): <T>(identifier: string | symbol | interfaces.Newable<T> | interfaces.Abstract<T>, dependencies?: (string | symbol | interfaces.Newable<any> | interfaces.Abstract<any> | helperInterfaces.BasicInjection | helperInterfaces.NamedInjection | helperInterfaces.TaggedInjection)[], constraint?: ((binding: interfaces.BindingInWhenOnSyntax<T>) => void) | undefined) => (constructor: interfaces.Newable<T>) => void;
declare function registerSelf(container: interfaces.Container): <T>(dependencies?: (string | symbol | interfaces.Newable<any> | interfaces.Abstract<any> | helperInterfaces.BasicInjection | helperInterfaces.NamedInjection | helperInterfaces.TaggedInjection)[], constraint?: ((binding: interfaces.BindingInWhenOnSyntax<T>) => void) | undefined) => (constructor: interfaces.Newable<T>) => void;
declare function registerConstructor(container: interfaces.Container): <T>(identifier: string | symbol | interfaces.Newable<T> | interfaces.Abstract<T>, constraint?: ((binding: interfaces.BindingWhenOnSyntax<T>) => void) | undefined) => (constructor: interfaces.Newable<T>) => void;
declare function registerConstantValue(container: interfaces.Container): <T>(identifier: string | symbol | interfaces.Newable<T> | interfaces.Abstract<T>, value: T, constraint?: ((binding: interfaces.BindingWhenOnSyntax<T>) => void) | undefined) => void;
declare function registerDynamicValue(container: interfaces.Container): <T>(identifier: string | symbol | interfaces.Newable<T> | interfaces.Abstract<T>, func: (context: interfaces.Context) => T, constraint?: ((binding: interfaces.BindingInWhenOnSyntax<T>) => void) | undefined) => void;
declare function registerFunction(container: interfaces.Container): <T extends Function>(identifier: string | symbol | interfaces.Newable<T> | interfaces.Abstract<T>, func: T, constraint?: ((binding: interfaces.BindingWhenOnSyntax<T>) => void) | undefined) => void;
declare function registerAutoFactory(container: interfaces.Container): <T1, T2>(factoryIdentifier: string | symbol | interfaces.Newable<T1> | interfaces.Abstract<T1>, serviceIdentifier: string | symbol | interfaces.Newable<T2> | interfaces.Abstract<T2>, constraint?: ((binding: interfaces.BindingWhenOnSyntax<T1>) => void) | undefined) => void;
declare function registerFactory(container: interfaces.Container): <T1, T2>(identifier: string | symbol | interfaces.Newable<T1> | interfaces.Abstract<T1>, factory: interfaces.FactoryCreator<T2>, constraint?: ((binding: interfaces.BindingWhenOnSyntax<T1>) => void) | undefined) => void;
declare function registerProvider(container: interfaces.Container): <T1, T2>(identifier: string | symbol | interfaces.Newable<T1> | interfaces.Abstract<T1>, provider: interfaces.ProviderCreator<T2>, constraint?: ((binding: interfaces.BindingWhenOnSyntax<T1>) => void) | undefined) => void;
export { register, registerSelf, registerConstantValue, registerDynamicValue, registerConstructor, registerFunction, registerAutoFactory, registerFactory, registerProvider };
