"use strict";
var inversify_1 = require("inversify");
function annotate(constructor, dependencies) {
    if (dependencies === void 0) { dependencies = []; }
    inversify_1.decorate(inversify_1.injectable(), constructor);
    (dependencies).forEach(function (injection, index) {
        if (injection.type === undefined) {
            inversify_1.decorate(inversify_1.inject(injection), constructor, index);
        }
        else {
            inversify_1.decorate(inversify_1.inject(injection.type), constructor, index);
            if (injection.named !== undefined) {
                inversify_1.decorate(inversify_1.named(injection.named), constructor, index);
            }
            if (injection.tagged !== undefined) {
                inversify_1.decorate(inversify_1.tagged(injection.tagged.key, injection.tagged.value), constructor, index);
            }
        }
    });
}
exports.annotate = annotate;
